﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private wbvTable As WebView
	Private lblSelectedItem As Label
	Private HtmlCSS As String
	HtmlCSS = "table {width: 100%;border: 1px solid #cef;text-align: left; }" _
		& " th { font-weight: bold;	background-color: #acf;	border-bottom: 1px solid #cef; }" _ 
		& "td,th {	padding: 4px 5px; }" _
		& ".odd {background-color: #def; } .odd td {border-bottom: 1px solid #cef; }" _
		& "a { text-decoration:none; color: #000;}"
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Eventsdatas")
	ShowTable
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub ShowTable
	Private Query As String
	
	Query = "SELECT Events,Class As CS,Stream As Str,Dates FROM Eventsinfo"
	'depending if the filter is active or not we add the filter query at the end of the query
	'the filter query is defined in the Filter Activity
	
	'displays the database in a table
	wbvTable.LoadHtml(ExecuteHtml(Starter.SQL1, Query, Null, 0, True))
	ReadDataBaseIDs
End Sub
Sub ReadDataBaseIDs
	Private Row As Int
	Private cursor1 As Cursor
	
	Starter.IDList.Initialize		'initialize the ID list

	'We read only the ID column and put them in a List
	If Starter.flagFilterActive = False Then
		cursor1 = Starter.SQL1.ExecQuery("SELECT Id FROM Eventsinfo")
	Else
		cursor1 = Starter.SQL1.ExecQuery("SELECT Id FROM Eventsinfo" & Starter.FilterQuery)
	End If
	
	If cursor1.RowCount > 0 Then						'check if entries exist
		Starter.RowNumber = cursor1.RowCount					'set the row count variable
		Starter.IDList.Initialize											'initialize the ID list
		For Row = 0 To  Starter.RowNumber - 1
			cursor1.Position = Row							'set the Cursor to each row
			Starter.IDList.Add(cursor1.GetInt("Id"))		'add the ID's to the ID list
		Next
		Starter.CurrentIndex = 0											'set the current index to 0
	Else
		Starter.CurrentIndex = -1											'set the current index to -1, no selected item
		ToastMessageShow("No items found", False)
	End If
	cursor1.Close														'close the cursor, we don't need it anymore
End Sub
Sub wbvTable_OverrideUrl (Url As String) As Boolean
	'parse the row and column numbers from the URL
	Private values() As String
	values = Regex.Split("[.]", Url.SubString(7))
	Private row As Int
	row = values(1)
	Starter.CurrentIndex = row
	UpdateSelectedItem
	Return True 'Don't try to navigate to this URL
End Sub

Sub UpdateSelectedItem
	Private Query As String
	Private Curs As Cursor
	
	Query = "SELECT Events, Class,Stream FROM Eventsinfo WHERE Id = " & Starter.IDList.Get(Starter.CurrentIndex)
	Curs = Starter.SQL1.ExecQuery(Query)
	Curs.Position = 0
	lblSelectedItem.Text = Curs.GetString("Events") & " " & Curs.GetString("Class")& " " & Curs.GetString("Stream")
	Curs.Close
End Sub
Sub ExecuteHtml(SQL As SQL, Query As String, StringArgs() As String, Limit As Int, Clickable As Boolean) As String
	Private cur As Cursor
	If StringArgs <> Null Then
		cur = SQL.ExecQuery2(Query, StringArgs)
	Else
		cur = SQL.ExecQuery(Query)
	End If
	Log("ExecuteHtml: " & Query)
	If Limit > 0 Then Limit = Min(Limit, cur.RowCount) Else Limit = cur.RowCount
	Private sb As StringBuilder
	sb.Initialize
	sb.Append("<html><body>").Append(CRLF)
	sb.Append("<style type='text/css'>").Append(HtmlCSS).Append("</style>").Append(CRLF)
	sb.Append("<table><tr>").Append(CRLF)
	For i = 0 To cur.ColumnCount - 1
		sb.Append("<th>").Append(cur.GetColumnName(i)).Append("</th>")
	Next
	
	sb.Append("</tr>").Append(CRLF)
	For row = 0 To Limit - 1
		cur.Position = row
		If row Mod 2 = 0 Then
			sb.Append("<tr>")
		Else
			sb.Append("<tr class='odd'>")
		End If
		For i = 0 To cur.ColumnCount - 1
			sb.Append("<td>")
			If Clickable Then
				sb.Append("<a href='http://").Append(i).Append(".")
				sb.Append(row)
'				sb.Append(".com'>").Append(cur.GetString2(i)).Append("</a>")
				sb.Append(".stub'>").Append(cur.GetString2(i)).Append("</a>")
		
			Else
				sb.Append(cur.GetString2(i))
			End If
			sb.Append("</td>")
		Next
		sb.Append("</tr>").Append(CRLF)
		
	Next
	cur.Close
	sb.Append("</table></body></html>")
	Return sb.ToString
End Sub